#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
//
//FFBE00BD3F78F7AE 65D1C6AD8EBD1A14 A0A1A2A3A4A5A6A7
//decrypted CW used to decrypt DVB stream
//unsigned char dcw[] = { 0xf1,0x9d,0x90,0x1e,0xb7,0xf2,0xe2,0x8b };
//unsigned char dcw[] = { 0xFF,0xBE,0x00,0xBD,0x3F,0x78,0xF7,0xAE };
//camkey crypted CW
//unsigned char ckc_cw[] = { 0x30, 0x57, 0xc8, 0xa0, 0xe5, 0x2b, 0xee, 0xb3 };
//unsigned char ckc_cw[] = { 0x65, 0xD1, 0xC6, 0xAD, 0x8E, 0xBD, 0x1A, 0x14 };

unsigned char const_camkey[] = { 0xa0, 0xa1, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7 };

static const unsigned char CryptTable[256] =
{
  0xDA, 0x26, 0xE8, 0x72, 0x11, 0x52, 0x3E, 0x46,
  0x32, 0xFF, 0x8C, 0x1E, 0xA7, 0xBE, 0x2C, 0x29,
  0x5F, 0x86, 0x7E, 0x75, 0x0A, 0x08, 0xA5, 0x21,
  0x61, 0xFB, 0x7A, 0x58, 0x60, 0xF7, 0x81, 0x4F,
  0xE4, 0xFC, 0xDF, 0xB1, 0xBB, 0x6A, 0x02, 0xB3,
  0x0B, 0x6E, 0x5D, 0x5C, 0xD5, 0xCF, 0xCA, 0x2A,
  0x14, 0xB7, 0x90, 0xF3, 0xD9, 0x37, 0x3A, 0x59,
  0x44, 0x69, 0xC9, 0x78, 0x30, 0x16, 0x39, 0x9A,
  0x0D, 0x05, 0x1F, 0x8B, 0x5E, 0xEE, 0x1B, 0xC4,
  0x76, 0x43, 0xBD, 0xEB, 0x42, 0xEF, 0xF9, 0xD0,
  0x4D, 0xE3, 0xF4, 0x57, 0x56, 0xA3, 0x0F, 0xA6,
  0x50, 0xFD, 0xDE, 0xD2, 0x80, 0x4C, 0xD3, 0xCB,
  0xF8, 0x49, 0x8F, 0x22, 0x71, 0x84, 0x33, 0xE0,
  0x47, 0xC2, 0x93, 0xBC, 0x7C, 0x3B, 0x9C, 0x7D,
  0xEC, 0xC3, 0xF1, 0x89, 0xCE, 0x98, 0xA2, 0xE1,
  0xC1, 0xF2, 0x27, 0x12, 0x01, 0xEA, 0xE5, 0x9B,
  0x25, 0x87, 0x96, 0x7B, 0x34, 0x45, 0xAD, 0xD1,
  0xB5, 0xDB, 0x83, 0x55, 0xB0, 0x9E, 0x19, 0xD7,
  0x17, 0xC6, 0x35, 0xD8, 0xF0, 0xAE, 0xD4, 0x2B,
  0x1D, 0xA0, 0x99, 0x8A, 0x15, 0x00, 0xAF, 0x2D,
  0x09, 0xA8, 0xF5, 0x6C, 0xA1, 0x63, 0x67, 0x51,
  0x3C, 0xB2, 0xC0, 0xED, 0x94, 0x03, 0x6F, 0xBA,
  0x3F, 0x4E, 0x62, 0x92, 0x85, 0xDD, 0xAB, 0xFE,
  0x10, 0x2E, 0x68, 0x65, 0xE7, 0x04, 0xF6, 0x0C,
  0x20, 0x1C, 0xA9, 0x53, 0x40, 0x77, 0x2F, 0xA4,
  0xFA, 0x6D, 0x73, 0x28, 0xE2, 0xCD, 0x79, 0xC8,
  0x97, 0x66, 0x8E, 0x82, 0x74, 0x06, 0xC7, 0x88,
  0x1A, 0x4A, 0x6B, 0xCC, 0x41, 0xE9, 0x9D, 0xB8,
  0x23, 0x9F, 0x3D, 0xBF, 0x8D, 0x95, 0xC5, 0x13,
  0xB9, 0x24, 0x5A, 0xDC, 0x64, 0x18, 0x38, 0x91,
  0x7F, 0x5B, 0x70, 0x54, 0x07, 0xB6, 0x4B, 0x0E,
  0x36, 0xAC, 0x31, 0xE6, 0xD6, 0x48, 0xAA, 0xB4

};


static void XRotateLeft8Byte(unsigned char *buf)
{
  int k;
  unsigned char t1=buf[7];
  unsigned char t2=0;
  for(k=0; k<=7; k++)
  {
    t2=t1;
    t1=buf[k];
    buf[k]=(buf[k]<<1)|(t2>>7);
  }
}

inline static void ReverseSessionKeyCrypt(const unsigned char *camkey, unsigned char *key)
{
  unsigned char localkey[8], tmp1, tmp2;
  int idx1,idx2;

  memcpy(localkey, camkey, 8) ;
  for(idx1=0; idx1<8; idx1++)
  {
    for(idx2=0; idx2<8; idx2++)
    {
      tmp1 = CryptTable[key[7] ^ localkey[idx2] ^ idx1] ;
      tmp2 = key[0] ;
      key[0] = key[1] ;
      key[1] = key[2] ;
      key[2] = key[3] ;
      key[3] = key[4] ;
      key[4] = key[5] ;
      key[5] = key[6] ^ tmp1 ;
      key[6] = key[7] ;
      key[7] = tmp1 ^ tmp2 ;
    }
    XRotateLeft8Byte(localkey);
  } 
}
void XRotateRight8Byte(unsigned char *key)
{
  unsigned char t1=key[0];
  int k;
  for(k=7 ; k>=0 ; k--) {
    unsigned char t2=t1<<7;
    t1=key[k]; key[k]=(t1>>1) | t2;
    }
}

void SessionKeyCrypt(const unsigned char *key, unsigned char *data)
{
  unsigned char localKey[8];
  int idx1, idx2;
  memcpy(localKey,key,sizeof(localKey));
  for(idx1=0 ; idx1<7 ; idx1++) XRotateLeft8Byte(localKey);
  for(idx1=7 ; idx1>=0 ; idx1--) {
    for(idx2=7 ; idx2>=0 ; idx2--) {
      const unsigned char tmp1=CryptTable[data[6] ^ localKey[idx2] ^ idx1];
      const unsigned char tmp2=data[0];
      data[0]=data[7] ^ tmp1;
      data[7]=data[6];
      data[6]=data[5] ^ tmp1;
      data[5]=data[4];
      data[4]=data[3];
      data[3]=data[2];
      data[2]=data[1];
      data[1]=tmp2;
      }
    XRotateRight8Byte(localKey);
    }
}

void print_key(const char *msg, unsigned char *key)
{
  int j;
  printf("%s", msg);
  for(j = 0; j < 8; j++) printf("%02X ", key[j]);
  printf("\n");
}

inline void ull2b(unsigned long long i, unsigned char *b)
{
  b[0]=(i>>56) & 0xff;
  b[1]=(i>>48) & 0xff;
  b[2]=(i>>40) & 0xff;
  b[3]=(i>>32) & 0xff;
  b[4]=(i>>24) & 0xff;
  b[5]=(i>>16) & 0xff;
  b[6]=(i>> 8) & 0xff;
  b[7]=(i    ) & 0xff;
}
unsigned long long b2ull(unsigned char *b)
{
  int i;
  unsigned long long k = 0;
  for(i = 0; i < 8; k += b[i++]) k <<= 8;
  return(k);
}

static int gethexval(char c)
{
  if ((c>='0') && (c<='9')) return(c-'0');
  if ((c>='A') && (c<='F')) return(c-'A'+10);
  if ((c>='a') && (c<='f')) return(c-'a'+10);
  return(-1);
}

int atob(unsigned char *buf, char *asc, int n)
{
  int i, rc;
  for (i=0; i<n; i++)
  {
    if ((rc=(gethexval(asc[i<<1])<<4)|gethexval(asc[(i<<1)+1]))&0x100)
      return(-1);
    buf[i]=rc;
  }
  return(n);
}

int asalmibak (unsigned long long sayikontrol)
{   
       unsigned long long b, c, d;
	b=sayikontrol;
 
        d = 1;
        for (c = 2; c < b; c ++)
        {
           if (b % c == 0)
           {
             d = 0;
             break;
           }
        }
        if (d == 1) return 1;
   	  else
         {    printf("ASAL DEGIL =%llu\n ", b);
   		return 0;
         }
}

int main(int argc, char **argv)
{
  if( argc < 5 )		// If the arguments missing write the usage.
  {
    printf("\n\nUsage -->   irdckc DCW ECW FROM_CK TO_CK\n\n DCW     - decrypted CW\n ckCW    - camkey crypted (encrypted) CW\n FROM_CK - start brute from specified camkey\n TO_CK   - stop brute force at this camkey\n\n");
    printf("example: ./irdckc FFBE00BD3F78F7AE 65D1C6AD8EBD1A14 A0A1A2A3A4000000 A0A1A2A3A4A5A6A7 \n\n");
    return 0;
  }

  unsigned char dcw[8], ckc_cw[8], camkey[8], tmp[8], camkey_stop[8], camkey_start[8];	// Camkey iterations initializing.
  int j, oddoreven, primecounter;									// Prime check.
  unsigned long long i, do_once, key_s, ii, key_stop;						// Define long variables for key check.
  time_t ts, tc;											// Define time variables.

  memset(ckc_cw     	, 0, 8);									// Initialize ecw.
  atob(ckc_cw, argv[2], 8);										// Second argument is ecw.

  memset(camkey     	, 0, 8);									// Initialize camkey start.
  atob(camkey, argv[3], 8);										// Third argument is starting CAMKEY.

  memset(camkey_start, 0, 8);									// Initialize camkey_start.
  atob(camkey_start, argv[3], 8);									// Define as camkey_start.
	
  memset(camkey_stop , 0, 8);									// Initialize camkey_stop.
  atob(camkey_stop, argv[4], 8);									// Fourth argument is end CAMKEY. 

  memset(dcw , 0, 8);										// Initialize dcw.
  atob(dcw, argv[1], 8);										// First argument is dcw.

  memset(tmp     	, 0, 8);									// Initialize tmp.

  i = b2ull(camkey);
  key_s = i;												// decimal starting CAMKEY.
  ii = b2ull(camkey_stop);		
  key_stop = ii;											// decimal end CAMKEY.
  ull2b(i, camkey);

  if( key_stop < key_s )
  {
    printf("\n\nUsage -->   irdckc DCW ECW FROM_CK TO_CK\n\n DCW     - decrypted CW\n ckCW    - camkey crypted (encrypted) CW\n FROM_CK - start brute from specified camkey\n TO_CK   - stop brute force at this camkey\n\n");
    printf("example: ./irdckc FFBE00BD3F78F7AE 65D1C6AD8EBD1A14 A0A1A2A3A4000000 A0A1A2A3A4A5A6A7 \n\n");
    return 0;
  }
  print_key("\nplain CW is      ", dcw);
  print_key("crypted CW is    ", ckc_cw);
  print_key("brute-force from ", camkey);
  print_key("brute-force to   ", camkey_stop);
  ts = time(NULL);

  printf("LAST  Iteration  will be inspected = '%llu' \n", key_stop);
  printf("FIRST Iteration  will be inspected = '%llu' \n", key_s);
  printf("TOTAL Iterations will be inspected = '%llu' \n", key_stop - key_s);

/*
  if ( key_s % 2== 0 ) 
  {
    key_s+=1;
    i+=1;
    oddoreven=1;
  }
   else 
    oddoreven=0;*/

  do_once=1;
  while( ((i) && (i <= key_stop)) || do_once )
  {
    do_once=0;
    ull2b(i, camkey);
    /*while ( (i % 3== 0) || (i % 5== 0) || (i % 7== 0) || (i % 9== 0) || (i % 11== 0) || (i % 13== 0) || (i % 17== 0) || (i % 19== 0) || (i % 23== 0) ) 
    {
      i+=2;
    }*/
    memcpy(tmp, ckc_cw, 8);

    ReverseSessionKeyCrypt(camkey, tmp);

    if(!memcmp(tmp, dcw, 8))
    {
      tc = time(NULL);
     
      //unsigned char token[]="camkey.log";
      FILE *fp;
      if (!(fp = fopen ("camkey.log", "a"))) 
        {
	  printf("ERROR: Cannot open file  \n");
        } 
      else 
        {
	 int jj;
	 fprintf(fp, "\nplain CW is       = ");
  	 for(jj = 0; jj < 8; jj++) fprintf(fp, "%02X ", dcw[jj]);
  	 fprintf(fp, "\ncrypted CW is     = ");
  	 for(jj = 0; jj < 8; jj++) fprintf(fp, "%02X ", ckc_cw[jj]);
  	 fprintf(fp, "\nbrute-force from  = ");
  	 for(jj = 0; jj < 8; jj++) fprintf(fp, "%02X ", camkey_start[jj]);
  	 fprintf(fp, "\nbrute-force to    = ");
  	 for(jj = 0; jj < 8; jj++) fprintf(fp, "%02X ", camkey_stop[jj]);

        fprintf(fp, "LAST  Iteration  will be inspected = '%llu' \n", key_stop);
        fprintf(fp, "FIRST Iteration  will be inspected = '%llu' \n", key_s);
        fprintf(fp, "TOTAL Iterations will be inspected = '%llu' \n", key_stop - key_s);

	 fprintf (fp, "\n\nCAMKEY hex found      = ");
  	 for(jj = 0; jj < 8; jj++) fprintf(fp, "%02X ", camkey[jj]);
        fprintf (fp, "\nCAMKEY dec found      = '%llu' \n", b2ull(camkey));
	 fprintf(fp, "\nbrute-force took %lu seconds for %llu iterations\n", tc - ts, i - key_s);
  	 fprintf(fp, "\n");

         fclose (fp);
        }

      printf("\nCAMKEY dec found = '%llu'", b2ull(camkey));
      print_key("\nCAMKEY hex found = ", camkey);
      printf("brute-force took %lu seconds for %llu iterations\n", tc - ts, i - key_s);
      return 1;
    }
    i++;
    //i+=2;
  }
  tc = time(NULL);
  printf("\nbrute-force took %lu seconds for %llu iterations\n", tc - ts, i - key_s);
  printf("camkey not found\n");
  return 0;
}


// C23E9D9DD18287F6A75D6F848246E3CE
// 613CB818BA6220C74DF3CE5EBBDE6AB8
// 9C0A7B7F7950F1E02E9B8E653F039CF2
// FF83D50096B20685983E69CF13691A61
// AB9DC0A920

